//------------------------------------------------------------------------------------------------------------------------
// SEGPAL - Bibliothèque de composants XCOS pour HYDROTUR
//
// Fonction			:	Satur
// Auteur			:	PERRICHON Pierre
// Date				:	29/12/2018
// Version			:	1.0
//
// Sujet			: 	Saturations externes
//
// Paramétrage		:	
//						
//						
//						
//
// Autres données	:	
//						
//						
// Sorties			:	Saturations appliquées au signal d'entrée
//						
// Modification		:
// Auteur			:	PERRICHON Pierre
// Date				:	28/08/2021
// Version			:	1.1
//
// Description		!	L'entrée "in" et la sortie "out" sont vectorisées nx1 soit n lignes
//						
//						
// Interface IHM	:	Satur.sci
// Code objet		;	SaturC.c 
//
// Programme de test:	Satur.zos
//
//------------------------------------------------------------------------------------------------------------------------
function [sciblk, s1, s2]=Satur(job, sciblk, e1)

	s1= []; s2 = [];	// arguments requis mais non utilisés 
	typ=[];
	
	select job
	
		case "set" then
		
			style_properties = ["blockWithLabel";
                        "verticalLabelPosition=middle";
                        "verticalAlign=middle";
						"fillColor=#abcdee";
						"fontColor=blue";
						"displayedLabel=SATUR"];
			sciblk.graphics.style = strcat(style_properties,";");
			sciblk.graphics.in_label=["in", "Max", "Min"]
			sciblk.graphics.out_label=["out"]			
		

		case "define" then

			exprs=[]

			model=scicos_model()

			model.in = [-1;-2;-3]			// Modif PPe le 27.08.2021
			model.in2 = [1;1;1]
			model.intyp = [1;1;1]
			
			model.out = -1					// Modif PPe le 27.08.2021
			model.out2 = 1
			model.outtyp = 1

			model.sim=list("SaturC",4)
			model.blocktype="c"

			model.evtin=[]			
			model.state = []
			model.rpar = []
			model.ipar = []
			model.opar = list()

			model.dep_ut = [%t,%f]			

			sciblk=standard_define([5 4],model,exprs);
		
			style_properties = ["blockWithLabel";
                        "verticalLabelPosition=middle";
                        "verticalAlign=middle";
						"fillColor=#abcdee";
						"fontColor=blue";
						"displayedLabel=SATUR"];
			sciblk.graphics.style = strcat(style_properties,";");
			sciblk.graphics.in_label=["in", "Max", "Min"]
			sciblk.graphics.out_label=["out"]

	end
	
endfunction
