//------------------------------------------------------------------------------------------------------------------------
// SEGPAL - Bibliothèque de composants XCOS pour HYDROTUR
//
// Fonction			:	Pow
// Auteur			:	PERRICHON Pierre
// Date				:	01/05/2014
// Version			:	1.0
//
// Sujet			: 	Elévation à la puissance
//
// Paramétrage		:	Valeur de l'exposant
//						
//						
//						
//
// Autres données	:	...Introduit pour afficher l'exposant dans la boite
//						Bug Scilab 5.5.2 dans le composant POWBLK et donc correctif avec ce composant
//						
// Sorties			:	Entrée élevée à la puissance
//						
//						
//						
// Interface IHM	:	Pow.sci
// Code objet		;	ExponentC.c 
//
// Programme de test:	Pow.zos - Pow2.zcos
//
//------------------------------------------------------------------------------------------------------------------------
#include <math.h>
#include "scicos_block4.h"

void ExponentC(scicos_block *Cblk, scicos_flag flag)
{
		if(flag == OutputUpdate || flag == ReInitialization){
			// Evaluation de la fonction F
			//-----------------------------
			double *in = GetRealInPortPtrs(Cblk,1);  
			double *out = GetRealOutPortPtrs(Cblk,1);  
			
			int nrow = GetInPortRows(Cblk,1);  
			int ncol = GetInPortCols(Cblk,1);
			
			double *rpar=GetRparPtrs(Cblk);
			double a=rpar[0];

			int i=0;
			for (i = 0; i < nrow*ncol; i++)  out[i] = pow(in[i],a); 
		}
}