//------------------------------------------------------------------------------------------------------------------------
// SEGPAL - Bibliothèque de composants XCOS pour HYDROTUR
//
// Fonction			:	Hysteresis_H
// Auteur			:	PERRICHON Pierre
// Date				:	02/09/2021
// Version			:	1.0
//
// Sujet			: 	Hysteresis vectorié n lignes x 1 colonne
//
// Paramétrage		:	in1 size(m,1) type 1 - enable size(n,1) type 5 -  in2 size(m,1) 
//						out size n,1) type 1
//						m=1 type scalaire
//						m>1 on doit alors avoir m=n 
//
//						
//						
//						
//
// Autres données	:	
//						
//						
// Sorties			:	Hysteresis programmé sur chacune des entrées
//						
//						
// Interface IHM	:	Hysteresis_H.sci
// Code objet		;	Hysteresis_HC.c 
//
// Programme de test:	Hysteresis_H.zos
//
//------------------------------------------------------------------------------------------------------------------------
#include <math.h>
#include <stdio.h>
#include <sciprint.h>
#include "scicos_block4.h"

/*--------------------------------------------------------------------------*/
void  Hysteresis_HC(scicos_block *Cblk, int flag)
{
	
static char *Module="Hysteresis_HC";
	
	
int nlignes = GetInPortRows(Cblk,1); 			// Dimension de l'entrée in (nombre de ligne)
double *in = GetRealInPortPtrs(Cblk,1);
double *out = GetRealOutPortPtrs(Cblk,1);
double *rpar=GetRparPtrs(Cblk);

int i;

	switch (flag) {

		case Initialization:	
						for (i=0; i< nlignes; i++) {
								if(in[i]> rpar[1] && in[i]<rpar[0]) out[i]=rpar[3];
						}
						break;
						
		case ReInitialization:
								// sciprint("Nombre de lignes=%i\n",nlignes);	
		case OutputUpdate:	
						for (i=0; i < nlignes; i++) {
								if (in[i] >= rpar[0]) out[i] = rpar[2];
								 else if (in[i] <= rpar[1]) out[i] = rpar[3];
 						}
						break;
	}
}

